Installer - Bug #22479

Installer fails when run with --foreman-proxy-plugin-discovery-install-images true
02/01/2018 09:49 AM - Marek Hulan

Status: Closed
Assignee: Ewoud Kohl van Wijngaarden
Target version:
Pull request: https://github.com/theforeman/puppet-for

eman_proxy/pull/410

Description
When | run the installer like this

foreman-installer --enable-foreman-plugin-discovery --enable-foreman-proxy-plugin-discovery —--fore
man-proxy-plugin-discovery-install-images true

| get following error

Could not find dependency File[/var/lib/tftpboot/boot] for Foreman::Remote_file[/var/lib/tftpboot
/boot/fdi-image-latest.tar] at /usr/share/foreman-installer/modules/foreman_proxy/manifests/plugin
/discovery.pp:29
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/errors.rb:106:in "~ fail'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:1511:in “block in validate_relationship
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:1508:in “each'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:1508:1in ‘validate_relationship'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:2531:in “block in finish'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:2529:in “collect'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/type.rb:2529:in "~ finish'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/resource/catalog.rb:283:in "block in finalize'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/resource/catalog.rb:283:in “each'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/resource/catalog.rb:283:in "finalize'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:265:in ‘block in main'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/context.rb:65:in ‘override'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet.rb:306:in ‘“override'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:225:in "main'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:170:in " run_command'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application.rb:358:in “block in run'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:662:in ‘exit_on_fail'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application.rb:358:in "run'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/command_line.rb:132:in " run
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/command_line.rb:72:in ‘execute'
/opt/puppetlabs/puppet/bin/puppet:5:in " <main>'

The reason is that discovery puppet manifest relies on File resources which is not defined anywhere see
https://github.com/theforeman/puppet-foreman_proxy/blob/master/manifests/plugin/discovery.pp#L.32

The File for directory creation should probably be defined at
https:/github.com/theforeman/puppet-tftp/blob/master/manifests/config.pp or in discovery itself but I'm not entirely sure how exactly
this should behave or why the require is there.

Associated revisions

Revision b3a811ce - 02/26/2018 05:58 PM - Ewoud Kohl van Wijngaarden

Fixes #22479 - Handle remote directory with undefined parent
https://github.com/theforeman/puppet-foreman_proxy/blob/master/manifests/plugin/discovery.pp#L32
https://github.com/theforeman/puppet-tftp/blob/master/manifests/config.pp

This can happen when ftftp is set to false or unmanaged.
We move the remote_file define to this module since puppet-foreman no

longer uses it itself. That will allow us to remove it there in a next
major release.

History

#1 - 02/20/2018 09:28 AM - Ewoud Kohl van Wijngaarden

I'm guessing you also disabled tftp management in a previous installer run. Is that correct?

#2 - 02/21/2018 05:31 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/410 added

#3 - 02/26/2018 06:01 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset puppet-foreman_proxy|b3a811cefc2011dffb6fb1894a6fa98bc1di6724.
